Index: channels/chan_skinny.c
===================================================================
--- channels/chan_skinny.c	(revision 248854)
+++ channels/chan_skinny.c	(working copy)
@@ -2338,28 +2338,33 @@
 {
 	struct skinny_req *req;
 
-	if (text == 0) {
-		if (!(req = req_alloc(sizeof(struct clear_prompt_message), CLEAR_PROMPT_MESSAGE)))
-			return;
+	if (!(req = req_alloc(sizeof(struct display_prompt_status_message), DISPLAY_PROMPT_STATUS_MESSAGE)))
+		return;
 
-		req->data.clearpromptstatus.lineInstance = htolel(instance);
-		req->data.clearpromptstatus.callReference = htolel(callid);
+	ast_copy_string(req->data.displaypromptstatus.promptMessage, text, sizeof(req->data.displaypromptstatus.promptMessage));
+	req->data.displaypromptstatus.messageTimeout = htolel(t);
+	req->data.displaypromptstatus.lineInstance = htolel(instance);
+	req->data.displaypromptstatus.callReference = htolel(callid);
 
-		if (skinnydebug)
-			ast_verb(1, "Clearing Prompt\n");
-	} else {
-		if (!(req = req_alloc(sizeof(struct display_prompt_status_message), DISPLAY_PROMPT_STATUS_MESSAGE)))
-			return;
+	if (skinnydebug)
+		ast_verb(1, "Displaying Prompt Status '%s'\n", text);
 
-		ast_copy_string(req->data.displaypromptstatus.promptMessage, text, sizeof(req->data.displaypromptstatus.promptMessage));
-		req->data.displaypromptstatus.messageTimeout = htolel(t);
-		req->data.displaypromptstatus.lineInstance = htolel(instance);
-		req->data.displaypromptstatus.callReference = htolel(callid);
+	transmit_response(d, req);
+}
 
-		if (skinnydebug)
-			ast_verb(1, "Displaying Prompt Status '%s'\n", text);
-	}
+static void transmit_clearpromptmessage(struct skinny_device *d, int instance, int callid)
+{
+	struct skinny_req *req;
 
+	if (!(req = req_alloc(sizeof(struct clear_prompt_message), CLEAR_PROMPT_MESSAGE)))
+		return;
+
+	req->data.clearpromptstatus.lineInstance = htolel(instance);
+	req->data.clearpromptstatus.callReference = htolel(callid);
+
+	if (skinnydebug)
+		ast_verb(1, "Clearing Prompt\n");
+
 	transmit_response(d, req);
 }
 
@@ -2446,7 +2451,7 @@
 
 		transmit_speaker_mode(d, SKINNY_SPEAKEROFF);
 
-		transmit_displaypromptstatus(d, NULL, 0, instance, callid);
+		transmit_clearpromptmessage(d, instance, callid);
 	}
 
 	if (!(req = req_alloc(sizeof(struct call_state_message), CALL_STATE_MESSAGE)))
